package com.corelogic.sts;

import javax.annotation.Resource;
import javax.xml.ws.Service;
import javax.xml.ws.ServiceMode;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.WebServiceProvider;

import org.apache.cxf.annotations.EndpointProperties;
import org.apache.cxf.annotations.EndpointProperty;
import org.apache.cxf.interceptor.InInterceptors;
import org.picketlink.identity.federation.core.wstrust.PicketLinkSTS;

@WebServiceProvider(serviceName = "customPicketLinkSTS", 
					portName = "PicketLinkSTSPort", 
					targetNamespace = "http://corelogic.com/customPicketLinkSTS/1.0", 
					wsdlLocation = "WEB-INF/wsdl/PicketLinkSTS.wsdl")
@ServiceMode(value = Service.Mode.MESSAGE)
@EndpointProperties(value = {
		@EndpointProperty(key = "ws-security.signature.username", value = "mystskey"),
		@EndpointProperty(key = "ws-security.signature.properties", value = "stsKeystore.properties"),
		@EndpointProperty(key = "ws-security.callback-handler", value = "com.corelogic.sts.STSCallbackHandler"),
		@EndpointProperty(key = "ws-security.validate.token", value = "false")})
@InInterceptors(interceptors = {"org.jboss.wsf.stack.cxf.security.authentication.SubjectCreatingPolicyInterceptor"})
public class CustomPicketLinkSTS extends PicketLinkSTS {
  @Resource
  public void setWSC(WebServiceContext wctx) {
      this.context = wctx;
  }
}